# payments_api
#
# This file was automatically generated by APIMATIC v2.0
# ( https://apimatic.io ).

module PaymentsApi
  # QuotesController
  class QuotesController < BaseController
    def initialize(config, http_call_back: nil)
      super(config, http_call_back: http_call_back)
    end

    # Create new Quote
    # @param [String] bank_id Required parameter: Bank ID (Routing Number)
    # @param [Quote] body Required parameter: Quote data
    # @return [Quote] response from the API call
    def create_new_quote(bank_id,
                         body)
      # Prepare query url.
      _query_builder = config.get_base_uri
      _query_builder << '/quotes'
      _query_url = APIHelper.clean_url _query_builder

      # Prepare headers.
      _headers = {
        'accept' => 'application/json',
        'content-type' => 'application/json; charset=utf-8',
        'bankId' => bank_id
      }

      # Prepare and execute HttpRequest.
      _request = config.http_client.post(
        _query_url,
        headers: _headers,
        parameters: body.to_json
      )
      CustomHeaderAuth.apply(config, _request)
      _response = execute_request(_request)

      # Validate response against endpoint and global error codes.
      if _response.status_code == 400
        raise RequestErrorException.new(
          'Error in Request',
          _response
        )
      elsif _response.status_code == 403
        raise APIException.new(
          'Forbidden',
          _response
        )
      elsif _response.status_code == 500
        raise RequestErrorException.new(
          'System Error',
          _response
        )
      end
      validate_response(_response)

      # Return appropriate response type.
      decoded = APIHelper.json_deserialize(_response.raw_body)
      Quote.from_hash(decoded)
    end

    # Attempts to cancel a Quote
    # @param [String] bank_id Required parameter: Bank ID (Routing Number)
    # @param [Integer] quote_id Required parameter: ID of quote to refresh
    # @return [void] response from the API call
    def cancel_quote(bank_id,
                     quote_id)
      # Prepare query url.
      _query_builder = config.get_base_uri
      _query_builder << '/quotes/{quoteId}'
      _query_builder = APIHelper.append_url_with_template_parameters(
        _query_builder,
        'quoteId' => { 'value' => quote_id, 'encode' => true }
      )
      _query_url = APIHelper.clean_url _query_builder

      # Prepare headers.
      _headers = {
        'bankId' => bank_id
      }

      # Prepare and execute HttpRequest.
      _request = config.http_client.delete(
        _query_url,
        headers: _headers
      )
      CustomHeaderAuth.apply(config, _request)
      _response = execute_request(_request)

      # Validate response against endpoint and global error codes.
      if _response.status_code == 400
        raise RequestErrorException.new(
          'Error in Request',
          _response
        )
      elsif _response.status_code == 403
        raise APIException.new(
          'Forbidden',
          _response
        )
      elsif _response.status_code == 500
        raise RequestErrorException.new(
          'System Error',
          _response
        )
      end
      validate_response(_response)
    end

    # Lock the rate for a given Quote
    # @param [String] bank_id Required parameter: Bank ID (Routing Number)
    # @param [Integer] quote_id Required parameter: ID of quote to lock
    # @return [void] response from the API call
    def lock_quote(bank_id,
                   quote_id)
      # Prepare query url.
      _query_builder = config.get_base_uri
      _query_builder << '/quotes/{quoteId}/lock'
      _query_builder = APIHelper.append_url_with_template_parameters(
        _query_builder,
        'quoteId' => { 'value' => quote_id, 'encode' => true }
      )
      _query_url = APIHelper.clean_url _query_builder

      # Prepare headers.
      _headers = {
        'bankId' => bank_id
      }

      # Prepare and execute HttpRequest.
      _request = config.http_client.post(
        _query_url,
        headers: _headers
      )
      CustomHeaderAuth.apply(config, _request)
      _response = execute_request(_request)

      # Validate response against endpoint and global error codes.
      if _response.status_code == 400
        raise RequestErrorException.new(
          'Error in Request',
          _response
        )
      elsif _response.status_code == 403
        raise APIException.new(
          'Forbidden',
          _response
        )
      elsif _response.status_code == 500
        raise RequestErrorException.new(
          'System Error',
          _response
        )
      end
      validate_response(_response)
    end

    # Refresh the rates for an existing Quote
    # @param [String] bank_id Required parameter: Bank ID (Routing Number)
    # @param [Integer] quote_id Required parameter: ID of quote to refresh
    # @return [Quote] response from the API call
    def refresh_quote(bank_id,
                      quote_id)
      # Prepare query url.
      _query_builder = config.get_base_uri
      _query_builder << '/quotes/{quoteId}/refresh'
      _query_builder = APIHelper.append_url_with_template_parameters(
        _query_builder,
        'quoteId' => { 'value' => quote_id, 'encode' => true }
      )
      _query_url = APIHelper.clean_url _query_builder

      # Prepare headers.
      _headers = {
        'accept' => 'application/json',
        'bankId' => bank_id
      }

      # Prepare and execute HttpRequest.
      _request = config.http_client.post(
        _query_url,
        headers: _headers
      )
      CustomHeaderAuth.apply(config, _request)
      _response = execute_request(_request)

      # Validate response against endpoint and global error codes.
      if _response.status_code == 400
        raise RequestErrorException.new(
          'Error in Request',
          _response
        )
      elsif _response.status_code == 403
        raise APIException.new(
          'Forbidden',
          _response
        )
      elsif _response.status_code == 500
        raise RequestErrorException.new(
          'System Error',
          _response
        )
      end
      validate_response(_response)

      # Return appropriate response type.
      decoded = APIHelper.json_deserialize(_response.raw_body)
      Quote.from_hash(decoded)
    end
  end
end
