# payments_api
#
# This file was automatically generated by APIMATIC v2.0
# ( https://apimatic.io ).

module PaymentsApi
  # Bank Information Object
  class Bank < BaseModel
    # Bank Name
    # @return [String]
    attr_accessor :name

    # Address Information
    # @return [Address]
    attr_accessor :address

    # Routing Code. Currently only supported for USD wires. When using, please
    # only provide SWIFT code OR routing code (not both)
    # @return [String]
    attr_accessor :routing_code

    # SWIFT BIC
    # @return [String]
    attr_accessor :swift_code

    # A mapping from model property names to API property names.
    def self.names
      @_hash = {} if @_hash.nil?
      @_hash['name'] = 'name'
      @_hash['address'] = 'address'
      @_hash['routing_code'] = 'routingCode'
      @_hash['swift_code'] = 'swiftCode'
      @_hash
    end

    def initialize(name = nil,
                   address = nil,
                   routing_code = nil,
                   swift_code = nil)
      @name = name
      @address = address
      @routing_code = routing_code
      @swift_code = swift_code
    end

    # Creates an instance of the object from a hash.
    def self.from_hash(hash)
      return nil unless hash

      # Extract variables from the hash.
      name = hash['name']
      address = Address.from_hash(hash['address']) if hash['address']
      routing_code = hash['routingCode']
      swift_code = hash['swiftCode']

      # Create object from extracted values.
      Bank.new(name,
               address,
               routing_code,
               swift_code)
    end
  end
end
