# payments_api
#
# This file was automatically generated by APIMATIC v2.0
# ( https://apimatic.io ).

module PaymentsApi
  # Payment Information Object
  class Payment < BaseModel
    # Payment ID
    # @return [Integer]
    attr_accessor :id

    # Quote ID
    # @return [Integer]
    attr_accessor :quote_id

    # Originator Information Object
    # @return [Originator]
    attr_accessor :originator

    # Bank Account Information Object.**NOTE** - originatorBankAccount bank data
    # should not be provided when creating a new Payment. This information is
    # retrieved from the database based on the provided bank ID.**NOTE** - bank
    # object is required for all BankAccount objects except
    # originatorBankAccount
    # @return [BankAccount]
    attr_accessor :originator_bank_account

    # Beneficiary Information Object
    # @return [Beneficiary]
    attr_accessor :beneficiary

    # Bank Account Information Object.**NOTE** - originatorBankAccount bank data
    # should not be provided when creating a new Payment. This information is
    # retrieved from the database based on the provided bank ID.**NOTE** - bank
    # object is required for all BankAccount objects except
    # originatorBankAccount
    # @return [BankAccount]
    attr_accessor :beneficiary_bank_account

    # Bank Account Information Object.**NOTE** - originatorBankAccount bank data
    # should not be provided when creating a new Payment. This information is
    # retrieved from the database based on the provided bank ID.**NOTE** - bank
    # object is required for all BankAccount objects except
    # originatorBankAccount
    # @return [BankAccount]
    attr_accessor :intermediary_bank_account

    # Payment Information Data
    # @return [PaymentDetails]
    attr_accessor :details

    # Payment Information Data
    # @return [PaymentStatus]
    attr_accessor :status

    # A mapping from model property names to API property names.
    def self.names
      @_hash = {} if @_hash.nil?
      @_hash['id'] = 'id'
      @_hash['quote_id'] = 'quoteId'
      @_hash['originator'] = 'originator'
      @_hash['originator_bank_account'] = 'originatorBankAccount'
      @_hash['beneficiary'] = 'beneficiary'
      @_hash['beneficiary_bank_account'] = 'beneficiaryBankAccount'
      @_hash['intermediary_bank_account'] = 'intermediaryBankAccount'
      @_hash['details'] = 'details'
      @_hash['status'] = 'status'
      @_hash
    end

    def initialize(quote_id = nil,
                   originator = nil,
                   beneficiary = nil,
                   beneficiary_bank_account = nil,
                   details = nil,
                   id = nil,
                   originator_bank_account = nil,
                   intermediary_bank_account = nil,
                   status = nil)
      @id = id
      @quote_id = quote_id
      @originator = originator
      @originator_bank_account = originator_bank_account
      @beneficiary = beneficiary
      @beneficiary_bank_account = beneficiary_bank_account
      @intermediary_bank_account = intermediary_bank_account
      @details = details
      @status = status
    end

    # Creates an instance of the object from a hash.
    def self.from_hash(hash)
      return nil unless hash

      # Extract variables from the hash.
      quote_id = hash['quoteId']
      originator = Originator.from_hash(hash['originator']) if
        hash['originator']
      beneficiary = Beneficiary.from_hash(hash['beneficiary']) if
        hash['beneficiary']
      if hash['beneficiaryBankAccount']
        beneficiary_bank_account = BankAccount.from_hash(hash['beneficiaryBankAccount'])
      end
      details = PaymentDetails.from_hash(hash['details']) if hash['details']
      id = hash['id']
      if hash['originatorBankAccount']
        originator_bank_account = BankAccount.from_hash(hash['originatorBankAccount'])
      end
      if hash['intermediaryBankAccount']
        intermediary_bank_account = BankAccount.from_hash(hash['intermediaryBankAccount'])
      end
      status = PaymentStatus.from_hash(hash['status']) if hash['status']

      # Create object from extracted values.
      Payment.new(quote_id,
                  originator,
                  beneficiary,
                  beneficiary_bank_account,
                  details,
                  id,
                  originator_bank_account,
                  intermediary_bank_account,
                  status)
    end
  end
end
