# payments_api
#
# This file was automatically generated by APIMATIC v2.0
# ( https://apimatic.io ).

module PaymentsApi
  # Quote Information Object
  class Quote < BaseModel
    # Quote ID
    # @return [Integer]
    attr_accessor :id

    # Amount to send in beneficiary currency. Not required if originatorAmount
    # is provided.
    # @return [Float]
    attr_accessor :beneficiary_amount

    # Beneficiary currency code in ISO 4217 format
    # @return [String]
    attr_accessor :beneficiary_currency

    # Amount to send in originator currency. Not required if beneficiaryAmount
    # is provided
    # @return [Float]
    attr_accessor :originator_amount

    # If true, then the originator amount is fixed to the provided value. If
    # false, then the beneficiary amount is fixed to the provided value. This
    # field is automatically set based on whether the originator or beneficary
    # amount was provided.
    # @return [Boolean]
    attr_accessor :originator_amount_is_fixed

    # The exchange rate for the quote
    # @return [Float]
    attr_accessor :exchange_rate

    # Set to true if the quote rate is locked
    # @return [Boolean]
    attr_accessor :locked

    # Quote revision number. This is automatically incremented each time the
    # quote is refreshed or updated, and starts from 1
    # @return [Integer]
    attr_accessor :revision

    # A mapping from model property names to API property names.
    def self.names
      @_hash = {} if @_hash.nil?
      @_hash['id'] = 'id'
      @_hash['beneficiary_amount'] = 'beneficiaryAmount'
      @_hash['beneficiary_currency'] = 'beneficiaryCurrency'
      @_hash['originator_amount'] = 'originatorAmount'
      @_hash['originator_amount_is_fixed'] = 'originatorAmountIsFixed'
      @_hash['exchange_rate'] = 'exchangeRate'
      @_hash['locked'] = 'locked'
      @_hash['revision'] = 'revision'
      @_hash
    end

    def initialize(beneficiary_currency = nil,
                   id = nil,
                   beneficiary_amount = nil,
                   originator_amount = nil,
                   originator_amount_is_fixed = nil,
                   exchange_rate = nil,
                   locked = nil,
                   revision = nil)
      @id = id
      @beneficiary_amount = beneficiary_amount
      @beneficiary_currency = beneficiary_currency
      @originator_amount = originator_amount
      @originator_amount_is_fixed = originator_amount_is_fixed
      @exchange_rate = exchange_rate
      @locked = locked
      @revision = revision
    end

    # Creates an instance of the object from a hash.
    def self.from_hash(hash)
      return nil unless hash

      # Extract variables from the hash.
      beneficiary_currency = hash['beneficiaryCurrency']
      id = hash['id']
      beneficiary_amount = hash['beneficiaryAmount']
      originator_amount = hash['originatorAmount']
      originator_amount_is_fixed = hash['originatorAmountIsFixed']
      exchange_rate = hash['exchangeRate']
      locked = hash['locked']
      revision = hash['revision']

      # Create object from extracted values.
      Quote.new(beneficiary_currency,
                id,
                beneficiary_amount,
                originator_amount,
                originator_amount_is_fixed,
                exchange_rate,
                locked,
                revision)
    end
  end
end
